
Redmine - Defect #20438

Subject filter doesn't work with non ASCII uppercase symbols

2015-07-29 18:07 - Alexandr Raz

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Jean-Philippe Lang % Done: 0%

Category: Issues Estimated time: 0.00 hour

Target version: 3.2.0   

Resolution: Fixed Affected version: 3.0.4

Description

If you search by containing cyrillic uppercase symbols, you get empty result. The query for search looks like

when "~"

sql = "LOWER(#{db_table}.#{db_field}) LIKE '%#{self.class.connection.quote_string(value.first.to_s.downcase)}%'"

but ruby function downcase wokrs only with latin symbols.

We add special private method:

def like_operator(content)

if Redmine::Database.postgresql?

"ILIKE '%#{content}%' "

else

"LIKE LOWER(#{content})"

end

end

and override method sql_for_field

when "~"

sql = "LOWER(#{db_table}.#{db_field}) #{like_operator(self.class.connection.quote_string(value.first.to_s.downcase))}"

when "!~"

sql = "LOWER(#{db_table}.#{db_field}) NOT #{like_operator(self.class.connection.quote_string(value.first.to_s.downcase))}"

Related issues:

Related to Redmine - Defect #3536: Case sensitivity in Issue filtering Closed 2009-06-25

Associated revisions

Revision 14476 - 2015-08-02 10:32 - Jean-Philippe Lang

Query doesn't work with non ASCII uppercase symbols (#20438).

History

#1 - 2015-07-30 01:17 - Toshi MARUYAMA

What db do you use?

If it is SQLite3, it does not work (r13760).

#2 - 2015-07-30 01:21 - Toshi MARUYAMA

- Status changed from New to Needs feedback

#3 - 2015-07-30 10:39 - Alexandr Raz

I'm using postgresql. I have a small experience with SQLite. How can I improve it?

#4 - 2015-07-30 13:19 - Toshi MARUYAMA

- Category changed from Search engine to Database

#5 - 2015-07-30 13:30 - Toshi MARUYAMA

- Subject changed from Search form doesn't work wtih cyrillic uppercase symbols. to Issue query doesn't work wtih non ASCII uppercase symbols.
https://www.redmine.org/projects/redmine/repository/svn/revisions/13760


- Category changed from Database to Issues

- Status changed from Needs feedback to New

- Target version set to 3.2.0

#6 - 2015-07-30 13:35 - Toshi MARUYAMA

- Subject changed from Issue query doesn't work wtih non ASCII uppercase symbols. to Query doesn't work wtih non ASCII uppercase symbols.

- Category deleted (Issues)

- Target version deleted (3.2.0)

#7 - 2015-07-30 13:41 - Toshi MARUYAMA

- Related to Defect #3536: Case sensitivity in Issue filtering added

#8 - 2015-07-30 13:48 - Toshi MARUYAMA

Please post by patch. I am confused with "query" and "search".

Please add tests like r2796 and r13767.

#9 - 2015-08-02 09:26 - Jean-Philippe Lang

- Target version set to 3.1.1

#10 - 2015-08-02 10:32 - Jean-Philippe Lang

- Subject changed from Query doesn't work wtih non ASCII uppercase symbols. to Subject filter doesn't work with non ASCII uppercase symbols

- Category set to Issues

- Status changed from New to Closed

- Assignee set to Jean-Philippe Lang

- Target version changed from 3.1.1 to 3.2.0

- Resolution set to Fixed

Fixed in r14476.
